/*******************************************************************************
 * Apache License, Version 2.0 (http://www.apache.org/licenses/LICENSE-2.0)
 * Copyright (c) 2011- kotemaru@kotemaru.org
 ******************************************************************************/
package org.kotemaru.auth;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.util.*;

/**
 * 認証局のインターフェース。
 */
public interface IdProvider  extends Serializable {
	/**
	 * 認証局を表す一意な名前を返す。
	 * <li>通常は認証サーバのURL。
	 * <li>RoleManagerが認証局をチェックするのに使用する。
	 * @return 認証局の名前
	 */
	public String getUniqName();
}
